﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Warship
{
    public partial class FormWarshipConfig : Form
    {

        DrawingWarship _warship = null;
        private event Action<DrawingWarship> EventAddWarship;
        public FormWarshipConfig()
        {
            InitializeComponent();
            PanelBlue.MouseDown += PanelColor_MouseDown;
            PanelCyan.MouseDown += PanelColor_MouseDown;
            PanelFuchsia.MouseDown += PanelColor_MouseDown;
            PanelLime.MouseDown += PanelColor_MouseDown;
            PanelOrange.MouseDown += PanelColor_MouseDown;
            PanelRed.MouseDown += PanelColor_MouseDown;
            PanelSilver.MouseDown += PanelColor_MouseDown;
            PanelYellow.MouseDown += PanelColor_MouseDown;
            ButtonCancel.Click += (sender, e) => Close();
        }

        private void DrawWarship()
        {
            Bitmap bmp = new(PictureBoxWarship.Width, PictureBoxWarship.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _warship?.SetPosition(5, 5, PictureBoxWarship.Width, PictureBoxWarship.Height);
            _warship?.DrawTransport(gr);
            PictureBoxWarship.Image = bmp;
        }

        public void AddEvent(Action<DrawingWarship> ev)
        {
            if (EventAddWarship == null)
            {
                EventAddWarship = ev;
            }
            else
            {
                EventAddWarship += ev;
            }
        }

        private void LabelWarship_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Label).DoDragDrop((sender as Label).Name, DragDropEffects.Move | DragDropEffects.Copy);
        }

        private void PanelWarship_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void PanelWarship_DragDrop(object sender, DragEventArgs e)
        {
            switch (e.Data.GetData(DataFormats.Text).ToString())
            {
                case "LabelBasicWarship":
                    _warship = new DrawingWarship((int)NumericUpDownSpeed.Value, (int)NumericUpDownWeight.Value, Color.White);
                    break;
                case "LabelAdvancedWarship":
                    _warship = new DrawingAdvancedWarship((int)NumericUpDownSpeed.Value, (int)NumericUpDownWeight.Value, Color.White, Color.Black, CheckBoxHelipad.Checked, CheckBoxAntenna.Checked, CheckBoxMissile.Checked);
                    break;
            }
            DrawWarship();
        }

        private void PanelColor_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Control).DoDragDrop((sender as Control).BackColor, DragDropEffects.Move | DragDropEffects.Copy);
        }

        private void LabelBodyColor_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(Color)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }
        private void LabelModifColor_DragEnter(object sender, DragEventArgs e)
        {
            if (_warship is DrawingAdvancedWarship)
            {
                if (e.Data.GetDataPresent(typeof(Color)))
                {
                    e.Effect = DragDropEffects.Copy;
                }
                else
                {
                    e.Effect = DragDropEffects.None;
                }
            }
        }

        private void LabelBodyColor_DragDrop(object sender, DragEventArgs e)
        {
            Color BodyColor = (Color)e.Data.GetData(typeof(Color));
            _warship.SetColor(BodyColor);
            DrawWarship();
        }

        private void LabelModifColor_DragDrop(object sender, DragEventArgs e)
        {
            Color ModifColor = (Color)e.Data.GetData(typeof(Color));
            if (_warship is DrawingAdvancedWarship AdvancedWarship)
            {
                AdvancedWarship.SetModifColor(ModifColor);
                DrawWarship();
            }
        }

        private void ButtomAdd_Click(object sender, EventArgs e)
        {
            EventAddWarship?.Invoke(_warship);
            Close();
        }
    }
}
